<?php

/*

    GTPhoto2 - A multi user photo album
    Copyright (C) 2004-2005 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

# this script provides wrappers for all of the database functions

function sql_connect($host, $user, $password, $database = "") {
	if (DATABASE_TYPE == "mysql") {
		return(mysql_connect($host, $user, $password));
	} elseif (DATABASE_TYPE == "mysqli") {
		global $db_link;
		if ($database == "") {
			$db_link = mysqli_connect($host, $user, $password);
		} else {
			$db_link = mysqli_connect($host, $user, $password, $database);
		}
		return $db_link;
	}
}

function sql_select_db($database,$db_link="") {
	if (DATABASE_TYPE == "mysql") {
		if ($db_link == "") {
			return(mysql_select_db($database));
		} else {
			return(mysql_select_db($database, $db_link));
		}
	} elseif (DATABASE_TYPE == "mysqli") {
		if ($db_link=="") {
			global $db_link;
		}
		return(mysqli_select_db($db_link,$database));
	}
}

function sql_query($sql,$db_link="") {
	$query_cache = array();
	if (DO_CACHING) {
		global $query_cache;
	}
	if (DEBUG) {
		echo ("<p>SQL Query: ".$sql);
	}
	if (DATABASE_TYPE == "mysql") {
		if ($query_cache[$sql]) {
			if (mysql_num_rows($query_cache[$sql]) > 0) {
				mysql_data_seek($query_cache[$sql],0);
			}
			if (DEBUG) {
				echo (" <b>cache hit</b></p>");
			}
			global $total_cached_sql_queries;
			$total_cached_sql_queries++;
			return $query_cache[$sql];
		} else {
			if (DEBUG) {
				echo (" <b>cache miss</b></p>");
			}
			$result = mysql_query($sql);
			if (mysql_error()) {
				puke("Mysql Error: ".mysql_error());
			} else {
				$query_cache[$sql] = $result;
				global $total_sql_queries;
				$total_sql_queries++;
				return $result;
			}
		}
	} elseif (DATABASE_TYPE == "mysqli") {
		if ($db_link=="") {
			global $db_link;
		}
		if ($query_cache[$sql]) {
			if (mysqli_num_rows($query_cache[$sql]) > 0) {
				mysqli_data_seek($query_cache[$sql],0);
			}
			if (DEBUG) {
				echo (" <b>cache hit</b></p>");
			}
			global $total_cached_sql_queries;
			$total_cached_sql_queries++;
			return $query_cache[$sql];
		} else {
			if (DEBUG) {
				echo (" <b>cache miss</b></p>");
			}
			$result = mysqli_query($db_link,$sql);
			if (mysqli_error($db_link)) {
				puke("Mysql Error: ".mysqli_error($db_link));
			} else {
				$query_cache[$sql] = $result;
				global $total_sql_queries;
				$total_sql_queries++;
				return $result;
			}
		}
	}
}

function sql_fetch_array($result) {
	if (DATABASE_TYPE == "mysql") {
		return(mysql_fetch_array($result));
	} elseif (DATABASE_TYPE == "mysqli") {
		return(mysqli_fetch_array($result));
	}
}

function sql_fetch_assoc($result) {
	if (DATABASE_TYPE == "mysql") {
		return(mysql_fetch_assoc($result));
	} elseif (DATABASE_TYPE == "mysqli") {
		return(mysqli_fetch_assoc($result));
	}
}

function sql_fetch_row($result) {
	if (DATABASE_TYPE == "mysql") {
		return(mysql_fetch_row($result));
	} elseif (DATABASE_TYPE == "mysqli") {
		return(mysqli_fetch_row($result));
	}
}

function sql_num_rows($result) {
	if (DATABASE_TYPE == "mysql") {
		return(mysql_num_rows($result));
	} elseif (DATABASE_TYPE == "mysqli") {
		return(mysqli_num_rows($result));
	}
}

function sql_insert_id($db_link="") {
	if (DATABASE_TYPE == "mysql") {
		return(mysql_insert_id());
	} elseif (DATABASE_TYPE == "mysqli") {
		if ($db_link=="") {
			global $db_link;
		}
		return(mysqli_insert_id($db_link));
	}
}

function sql_affected_rows($db_link="") {
	if (DATABASE_TYPE == "mysql") {
		return(mysql_affected_rows());
	} elseif (DATABASE_TYPE == "mysqli") {
		if ($db_link=="") {
			global $db_link;
		}
		return(mysqli_affected_rows($db_link));
	}
}

?>
